#include <cilk-cilk2c.h>
#line 1 "fib.cilk"
int atoi(char *);
int printf(char *,...);

         struct _fib_frame {StackFrameT header;struct {int n;} scope0;struct {int x;int y;} scope1;} ;static void _fib_slow(struct _fib_frame *_frame);int fib(int n){struct _fib_frame *_frame;_INIT_FRAME(_frame,sizeof(struct _fib_frame ),_fib_slow);
{
  if (n<2) 
    return (n);
  else 
    {
      int x;int y;
      {_frame->header.entry=1;_frame->scope0.n=n;_PUSH_FRAME(_frame);x=fib(n-1);_XPOP_FRAME_RESULT(_frame,0,x);}
      {_frame->header.entry=2;_frame->scope1.x=x;_PUSH_FRAME(_frame);y=fib(n-2);_XPOP_FRAME_RESULT(_frame,0,y);}
      /* sync */;
      return (x+y);
    }
}}
#line 4
         static void _fib_slow(struct _fib_frame *_frame){int n;switch (_frame->header.entry) {case 1: goto _sync1;case 2: goto _sync2;case 3: goto _sync3;}n=_frame->scope0.n;
{
  if (n<2) 
    {_SET_RESULT((n));_SET_VALID;return;}
  else 
    {

      {int _temp0;_frame->header.entry=1;_frame->scope0.n=n;_PUSH_FRAME(_frame);_temp0=fib(n-1);_XPOP_FRAME_RESULT(_frame,/* return nothing */,_temp0);_frame->scope1.x=_temp0;if (0) {_sync1:;n=_frame->scope0.n;}}
      {int _temp1;_frame->header.entry=2;_PUSH_FRAME(_frame);_temp1=fib(n-2);_XPOP_FRAME_RESULT(_frame,/* return nothing */,_temp1);_frame->scope1.y=_temp1;if (0) {_sync2:;}}
      {if (_SYNC) {_frame->header.entry=3;_HEAPIFY(_frame);return;_sync3:;}}
      {_SET_RESULT((_frame->scope1.x+_frame->scope1.y));_SET_VALID;return;}
    }
}}ProcInfoT _fib_sig[]={{0,0,0,0,0},{sizeof(int),offsetof(struct _fib_frame ,scope1.x),0,0,0},{sizeof(int),offsetof(struct _fib_frame ,scope1.y),0,0,0},{0,0,0,0,0},{-1,0,0,0,0}};

int fib_iter(int n)
{
     int f0;int f1;int f2;int i;
     if (n < 2) 
          return n;
     f0 = 0;
     f1 = 1;
     f2 = 1;
     for (i=2; i<=n; ++i) {
          f2 = f0 + f1;
          f0 = f1;
          f1 = f2;
     }

     return f2;
}


         struct _cilk_main_frame {StackFrameT header;struct {int argc;char**argv;} scope0;struct {int n;int answer;} scope1;} ;static void _cilk_main_slow(struct _cilk_main_frame *_frame);int cilk_main(int argc,char**argv){struct _cilk_main_frame *_frame;_INIT_FRAME(_frame,sizeof(struct _cilk_main_frame ),_cilk_main_slow);
{
  int n;int answer;

  n = atoi(argv[1]);
  {_frame->header.entry=1;_frame->scope1.n=n;_PUSH_FRAME(_frame);answer=fib(n);_XPOP_FRAME_RESULT(_frame,0,answer);}
  /* sync */;
  printf("fib(%d) = %d\n", n, answer);
  if (answer != fib_iter(n)) 
       printf("WRONG ANSWER!\n");

  return 0;
}}
#line 36
         static void _cilk_main_slow(struct _cilk_main_frame *_frame){int argc;char**argv;switch (_frame->header.entry) {case 1: goto _sync1;case 2: goto _sync2;}argc=_frame->scope0.argc;argv=_frame->scope0.argv;
{
  int n;

  n = atoi(argv[1]);
  {int _temp2;_frame->header.entry=1;_frame->scope1.n=n;_PUSH_FRAME(_frame);_temp2=fib(n);_XPOP_FRAME_RESULT(_frame,/* return nothing */,_temp2);_frame->scope1.answer=_temp2;if (0) {_sync1:;n=_frame->scope1.n;}}
  {if (_SYNC) {_frame->header.entry=2;_HEAPIFY(_frame);return;_sync2:;n=_frame->scope1.n;}}
  printf("fib(%d) = %d\n", n, _frame->scope1.answer);
  if (_frame->scope1.answer!=fib_iter(n)) 
       printf("WRONG ANSWER!\n");

  {_SET_RESULT(0);_SET_VALID;return;}
}}ProcInfoT _cilk_main_sig[]={{0,0,0,0,0},{sizeof(int),offsetof(struct _cilk_main_frame ,scope1.answer),0,0,0},{0,0,0,0,0},{-1,0,0,0,0}};ProcSigT _fib_sigs[]={{_fib_slow,_fib_sig},{_cilk_main_slow,_cilk_main_sig},{0,0}};ProcSigT _fib_sigs[];ProcSigT* Cilk_ProcSignatures[]={_fib_sigs,0};
