/*
 * $Id: cilk-lib.h,v 1.2 1996/06/07 17:55:44 athena Exp $
 */
/*
 * $Log: cilk-lib.h,v $
 * Revision 1.2  1996/06/07 17:55:44  athena
 * Fixed copyrights. I hate this.
 *
 * Revision 1.1  1996/06/05 15:37:41  athena
 * Added cilk-lib.h, and updated stuff
 *
 */

/*
 * Copyright (c) 1996 Massachusetts Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to use, copy, modify, and distribute the Software without
 * restriction, provided the Software, including any modified copies made
 * under this license, is not distributed for a fee, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE MASSACHUSETTS INSTITUTE OF TECHNOLOGY BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 * CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of the Massachusetts
 * Institute of Technology shall not be used in advertising or otherwise
 * to promote the sale, use or other dealings in this Software without
 * prior written authorization from the Massachusetts Institute of
 * Technology.
 *  
 */

/***********************************************************\
 * Exported variables and functions
\***********************************************************/

/* Number of processors Cilk is running on */
extern int Cilk_active_size;
/* Processor index of local processor */
extern int Self;

/* cactus stack shared-memory allocator */
extern void *Cilk_alloca(size_t size);

/* global malloc */
extern void *Cilk_malloc(size_t size);
extern void *Cilk_memalign(size_t alignment, size_t size);
extern void Cilk_free(void *s);

/* random number generator */
extern int Cilk_rand(void);
extern void Cilk_srand(unsigned int seed);
